unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls;

const
  Immagini = 5;

type
  TSlideShow = class(TForm)
    Comandi: TPanel;
    Timer: TTimer;
    NomeImmagine: TEdit;
    IntervalloInSecondi: TSpinEdit;
    Attivazione: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure AttivazioneClick(Sender: TObject);
    procedure IntervalloInSecondiChange(Sender: TObject);
  private
    { Private declarations }
  Bmps: Array[1..Immagini] of TBitmap;
  BmpSelezionata: Integer;
  public
    { Public declarations }
  end;

var
  SlideShow: TSlideShow;

implementation

{$R *.DFM}

procedure TSlideShow.FormCreate(Sender: TObject);
var
  a: Integer;
begin
  for a := 1 to Immagini do
  begin
    Bmps[a] := TBitmap.Create;
    Bmps[a].LoadFromFile('bitmap' + IntToStr(a) + '.bmp');
  end;
  BmpSelezionata := 1;
end;



procedure TSlideShow.FormDestroy(Sender: TObject);
{Descrizione di quello che succede quando viene distrutta la finestra}
var
  a: Integer;
{La variabile 'a'  un numero intero}
begin
  for a := 1 to Immagini do Bmps[a].Free;
  {per a = 1 fino a 5 allora libera la griglia di immagini}
  {Questa linea di codice NON  indispensabile, data la grande potenza e memoria 
dei
   computer attuali, ma  molto CORRETTA: viene liberata la parte di memoria 
occupata
   dal programma}
end;

procedure TSlideShow.FormPaint(Sender: TObject);
{Descrizione di quello che succede quando viene ridisegnata la finestra}
var
  x, y, w, h: Integer;
{Le variabili 'x', 'y', 'w', 'h' sono numeri interi}
begin
  w := Bmps[BmpSelezionata].Width;
  {w = larghezza in pixel dell'immagine selezionata}
  h := Bmps[BmpSelezionata].Height;
  {w = altezza in pixel dell'immagine selezionata}
  for x := 0 to (Width div w) do
  {per x = 0 fino a x = larghezza finestra diviso larghezza immagine selezionata allora...}
    for y := 0 to (Height div h) do
    {per y = 0 fino a y = altezza finestra diviso altezza immagine selezionata allora...}
      Canvas.Draw(x*w,y*h,Bmps[BmpSelezionata]);
      {disegna l'immagine tutte le volte che  necessario per riempire la finestra}
end;

procedure TSlideShow.TimerTimer(Sender: TObject);
begin
  Inc(BmpSelezionata);
  {Incrementa di 1 BmpSelezionata}
  if BmpSelezionata > Immagini then BmpSelezionata := 1;
  {Se BmpSelezionata  maggiore di Immagini, cio maggiore
   di 5, allora BmpSelezionata  uguale a 1}
  Paint;
  {Disegna l'immagine}
  NomeImmagine.Text := 'Bitmap' + IntToStr(BmpSelezionata);
  {Il testo di NomeImmagine  uguale a 'Bitmap' + DaInteroAStringa di
   BmpSelezionata}
end;

procedure TSlideShow.AttivazioneClick(Sender: TObject);
begin
  If Attivazione.Checked = True then
  {Se il pulsante  selezionato allora...}
  begin
    Timer.Enabled := True;
  {... Timer viene attivato}
  end;
  If Attivazione.Checked = False then
  {Se il pulsante NON  selezionato allora...}
  begin
    Timer.Enabled := False;
  {... Timer viene disattivato}
  end;
end;

procedure TSlideShow.IntervalloInSecondiChange(Sender: TObject);
  {Cosa succede quando CAMBIA il valore di IntervalloInSecondi?}
begin
  Timer.Interval := IntervalloInSecondi.Value * 1000;
  {Il valore "Interval" di Timer, cio l'intervallo di
   visualizzazione tra le immagini,  uguale al
   valore di IntervalloInSecondi per 1000}
end;

end.
